#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_NormalOutFishCFG7.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_NormalOutFishCFG7> Fish_NormalOutFishCFG7::msSingleton(nullptr);

int Fish_NormalOutFishCFG7::GetCount()
{
	return (int)mMapData.size();
}

const Fish_NormalOutFishCFG7Data* Fish_NormalOutFishCFG7::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_NormalOutFishCFG7Data>& Fish_NormalOutFishCFG7::GetMapData()
{
	return mMapData;
}

void Fish_NormalOutFishCFG7::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_NormalOutFishCFG7::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_NormalOutFishCFG7Data data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mType = element->IntAttribute("Type");
		data.mParamID = element->IntAttribute("ParamID");
		data.mOutWeight = element->IntAttribute("OutWeight");
		data.mOutMaxCount = element->IntAttribute("OutMaxCount");
		data.mRouteGroup = element->IntAttribute("RouteGroup");
		{
			const char* FishTime = element->Attribute("FishTime");
			std::vector<std::string> vecFishTime;
			boost::split(vecFishTime, FishTime, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFishTime.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFishTime[i].c_str(), &temp))
				{
					data.mFishTime.push_back(temp);
				}
			}
		}
		data.mGroupID = element->IntAttribute("GroupID");
		data.mFishNotice = element->IntAttribute("FishNotice");
		data.mGroupMaxFish = element->IntAttribute("GroupMaxFish");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_NormalOutFishCFG7::Load()
{
	Load("../Config/Fish_NormalOutFishCFG7.xml");
}

Fish_NormalOutFishCFG7* Fish_NormalOutFishCFG7::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_NormalOutFishCFG7());
	}
	return msSingleton.get();
}
